LeetCode-Lowest Common Ancestor of a Binary Search Tree-解題報告

原題鏈接 https://leetcode.com/problems/lowest-common-ancestor-of-a-binary-search-tree/

Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST.

According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes v and w as the lowest node in T that has both v and w as descendants (where we allow a node to be a descendant of itself).”

        _______6______
       /              \
    ___2__          ___8__
   /      \        /      \
   0      _4       7       9
         /  \
         3   5

For example, the lowest common ancestor (LCA) of nodes 2 and 8 is 6. Another example is LCA of nodes 2 and 4 is 2, since a node can be a descendant of itself according to the LCA definition.


找到最近公共祖先


我使用兩個hash表。

首先如果把root所在節點標記爲1則,他的左兒子標記爲2,右兒子標記爲3,對於一個標記爲x的節點,他的左兒子爲x*2,右兒子爲x*2+1;


所以我通過hash表PtoT,用標記映射地址。

另一個hash表VtoP,用值來映射標記。

當然可能存在相等的元素,因此我只記錄最小的標記。

得到p和q的標記後,表可以將p和q中標記最大的除以2,直到p和q相等結束。

然後用Ptov[p]返回即可。

當然程序是可以優化的,可以在找到兩個元素後便返回,不用記錄所有點。

空間也可以進一步優化,只記錄PtoT,而兩個元素的標記在dfs的記錄下來。


class Solution {
public:
	TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) {
		dfs(root, 1);
		int pp = VtoP[p->val];
		int pq = VtoP[q->val];
		while (pp != pq)
		{
			if (pp > pq)pp >>= 1;
			else pq >>= 1;
		}
		return PtoT[pp];
	}
	void dfs(TreeNode* root, int pos)
	{
		if (root == NULL)return;
		if (PtoT.find(pos) == PtoT.end())
		{
			PtoT[pos] = root;
			VtoP[root->val] = pos;
		}
		pos <<= 1;
		dfs(root->left, pos);
		dfs(root->right, pos + 1);
	}
private:
	unordered_map<int, TreeNode*>PtoT;
	unordered_map<int, int>VtoP;
};


 

發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章